// Tactics

// Very important
var li;
function enumEnemies(structyp) {
    li = [];
    var i;
    for (i = 0; i < maxPlayers; i++) {
        if (!allianceExistsBetween(me, i)) {
            li = li.concat(enumStruct(i, structyp));
        }
    }
    return li;
}

function enumAllies(structyp) {
    li = [];
    var i;
    for (i = 0; i < maxPlayers; i++) {
        if (allianceExistsBetween(me, i)) {
            li = li.concat(enumStruct(i, structyp));
        }
    }
    return li;
}

// Ordering functions
var dists = [];
var randand;
var randmax;
var minVal;
var armies;
function eventDroidIdle(droid) {
    if (droid.droidType == DROID_CONSTRUCT) {
        return;
    }
    if (droid.group == groups.vattackers) {
        sendToVAttack(droid); // Vtol attacking function
    } else if (droid.group != groups.spamborgs) {
        sendToAttack(droid);
    }
}

function sendToAttack(droid) {
    if (droid.group == groups.attackers || droid.group == groups.sensors) {
        estructs = enumEnemies(FACTORY).concat(enumEnemies(CYBORG_FACTORY).concat(
               enumEnemies(VTOL_FACTORY).concat(enumEnemies(RESEARCH_LAB).concat(
               enumEnemies(POWER_GEN).concat(enumEnemies(DEFENSE))))));
        var i;
        for (i = 0; i < estructs.length; i++) {
            dists[i] = [distBetweenTwoPoints(droid.x, droid.y, estructs[i].x, estructs[i].y), estructs[i]];
        }
        dists = sortLi2(dists);
        randmax = (maxPlayers < 5) ? 3 : 6;
        randand = randomNum(randmax) + 1;
        if (droid.player == me && droid.droidType != DROID_CONSTRUCT) {
            orderDroidLoc(droid, (droid.group == groups.sensors) ?
                          DORDER_MOVE : DORDER_SCOUT,
                          dists[randand][1].x,
                          dists[randand][1].y);
        }
    } else if (droid.group == groups.derattackers) {
        estructs = enumEnemies(RESOURCE_EXTRACTOR);
        var i;
        for (i = 0; i < estructs.length; i++) {
            dists[i] = [distBetweenTwoPoints(droid.x, droid.y, estructs[i].x, estructs[i].y), estructs[i]];
        }
        dists = sortLi2(dists);
        randmax = 3;
        randand = randomNum(randmax);
        orderDroidLoc(droid, DORDER_SCOUT, dists[randand][1].x, dists[randand][1].y);
    }
}

function sendToVAttack(droid) {
    estructs = enumEnemies(FACTORY).concat(enumEnemies(CYBORG_FACTORY).concat(
               enumEnemies(VTOL_FACTORY).concat(enumEnemies(RESEARCH_LAB).concat(
               enumEnemies(POWER_GEN).concat(enumEnemies(DEFENSE))))));
    orderDroidObj(droid, DORDER_ATTACK, estructs[0]);
}

// Attacking function
//function eventObjectSeen(viewer, seen) {
//    if (viewer.type == DROID
//        && viewer.player == me
//        && viewer.droidType != DROID_CONSTRUCT
//        && seen.type != FEATURE && !allianceExistsBetween(
//        viewer.player, seen.player)) {
//        orderDroidObj(viewer, (viewer.droidType == DROID_SENSOR) ? DORDER_OBSERVE : DORDER_ATTACK, seen);
//    }
//} (unused)

// This function helps to attack enemies not seen by a droid.
var midroids;
var repairer;
function eventAttacked(obj, attacker) {
    if (obj.player == me
        && obj.type == STRUCTURE
        && obj.stattype != RESOURCE_EXTRACTOR // We don't want you protecting any derricks please!
        && !allianceExistsBetween(obj.player, attacker.player)) {
            debug_("Protecting base against " + attacker);
            midroids = enumGroup(groups.defenders);
            var i;
            for (i = 0; i < midroids.length; i++) {
                orderDroidObj(midroids[i], DORDER_ATTACK, attacker);
            } 
    }
    if (obj.player == me
        && obj.type == DROID
        && obj.health < 65
        && !allianceExistsBetween(obj.player, attacker.player)) {
            debug_("Repairing " + obj);
            midroids = enumGroup(groups.repairs);
            if (midroids.length) {
                do { repairer = midroids[randomNum(midroids.length)]
                } while (!orderDroidObj(repairer, DORDER_REPAIR, obj));
            }
            orderDroid(obj, DORDER_RTR);
    }
}
